package com.icontrols.dust;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.converter.support.AllEncompassingFormHttpMessageConverter;
import org.springframework.web.client.RestTemplate;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class ReceiveiMapMutiSocket {
	private static final Logger logger = LoggerFactory.getLogger(ReceiveiMapMutiSocket.class);
	
	private static boolean bNewDanjiServer = true;
	 
	 
	 public static boolean isNewDanjiServer()
	 {
		 return bNewDanjiServer;
	 }
	 
	 public boolean isWindows()
	 {
		    String OS = System.getProperty("os.name").toLowerCase();
		    
		    if( OS.indexOf("win") >= 0 )
		    {
		    	logger.info("운영체제 - 윈도우");
		    	return true;
		    }
		    logger.info("운영체제 - 리눅스");
		    return false;
	 }
	 
	 public String getSiteCode()
	 {
		    String  checkFileName;
		    if( isWindows() )
		    {
		    	checkFileName = DEF.site_code_file;
		    }
		    else 
		    {
		    	checkFileName = DEF.site_code_file;
		    }
		    
			File checkFile = new File(checkFileName);
			
			logger.info("getSiteCode checkFile.exists() : " + checkFile.exists() );
			if (checkFile.exists())
			{
				try
				{
					BufferedReader reader = new BufferedReader(	new FileReader(checkFileName));
					String str;
					
					while ((str = reader.readLine()) != null) {
						logger.info("getSiteCode : " + str);
						DEF.site_code_value = str;
					}
				}catch(Exception e )
				{
					
				}

				return DEF.site_code_value;
			}
			else
				return null;
	 }
	 
	public ReceiveiMapMutiSocket()
	{

		String strSiteCode = getSiteCode();
		
		logger.info("****************************************");
		logger.info("Thread를 이용한 다중 접속 서버 작동됨...site_code : " + strSiteCode);
		logger.info("****************************************");

        ServerSocket server = null;
        long connectCount=0;
        
        try {
            server = new ServerSocket(DEF.WalladReceivePort);

            while(true) {
                // 클라이언트가 접속해 오기를 기다립니다.
                Socket connectedClientSocket = server.accept();

                InetAddress ia = connectedClientSocket.getInetAddress();
                int port = connectedClientSocket.getLocalPort();// 접속에 사용된 서버측 PORT 
                String ip = ia.getHostAddress(); // 접속된 원격 Client IP 
                
                // -------------------------------------------
                // 스레드 관련 부분
                // -------------------------------------------
                //Handler 클래스로 client 소켓 전송
                ThreadServerHandler handler = new ThreadServerHandler(connectedClientSocket , bNewDanjiServer);
                //스레드 시작, run()호출
                handler.start(); // start() --> run() 호출
                // -------------------------------------------
            }
        } catch(IOException ioe) {
            System.err.println("Exception generated...");
        } finally {
            try {
                server.close();
            } catch(IOException ignored) {}
        }
    }
}


//클라이언트로 데이터를 전송할 스레드 클래스
class ThreadServerHandler extends Thread {
	private static final Logger logger = LoggerFactory.getLogger(ThreadServerHandler.class);

	private Socket connectedClientSocket;
	 String XMLHeader;
	 String               strRcvMSG;
	 Document             doc;
	 
	 static final int EVENTTIMELIMITE = 2000;
	 static long lSocketConnectionPeriod = 0;
     static int TIMEOUT_iMAP_WAIT = 3000;   // iMAP 타임아웃
     static int SOCKET_BUFFER_SIZE_READ = 50;
     static boolean newDanjiServerNoticeUpdate = false; 
     
	 //생성자
	 public ThreadServerHandler(Socket connectedClientSocket , boolean server ) {
	  //Client와 통신할 객체를 초기값으로 받아 할당합니다.
	     this.connectedClientSocket = connectedClientSocket;  
	     this.newDanjiServerNoticeUpdate = server;
	     
		XMLHeader = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n"+
				"<imap ver = \"1.0\" address = \""+"10.0.1.1"+"\" sender = \""+"단지서버"+"\">\r\n";
	 }

	 //start() 메소드 호출 시 실행됩니다.
	 public void run() {
	     try {
	         //클라이언트로 내용을 출력 할 객체 생성
	    	 //InputStream InStm = connectedClientSocket.getInputStream();
	    	 
             InputStream InStm = connectedClientSocket.getInputStream();
             connectedClientSocket.setSoLinger(true, 3000);
             BufferedReader MsgReader = new BufferedReader(new InputStreamReader(InStm, "euc-kr"));
             strRcvMSG = "";
             String InBuffer;
             boolean bRcvOK = false;
             lSocketConnectionPeriod = System.currentTimeMillis() + TIMEOUT_iMAP_WAIT;   // 타임아웃시간을 설정한다.
             
             while (System.currentTimeMillis() < lSocketConnectionPeriod) {
                 try {
                     if (MsgReader.ready()) {
                         try {
                             char[] ReadData = new char[SOCKET_BUFFER_SIZE_READ * 1024];
                             InBuffer = "";
                             while (MsgReader.ready()) {
                                 long charCnt = MsgReader.read(ReadData);
                                 InBuffer += new String(ReadData, 0, (int)charCnt);
                             }
                             
                             if (InBuffer != null) strRcvMSG += InBuffer;
                             
                             if (0 < InBuffer.indexOf("</imap>")) {
                             	bRcvOK = true;
                             	//logger.debug("[iMAPSvrProc().run()] Received DONE!!");
                             	break;
                             }
                         } catch (Exception e) {
                         	 logger.error("message : " + e);
                             return;
                         }
                     }
                     else {
                         Thread.sleep(100);
                     }
                 } catch (Exception e) {
                 	 logger.debug("[Exception] iMAPSvrProc.run() ===== 2 =====");
                 	 connectedClientSocket.close();
                 	 logger.error("message : " + e);
                     return;
                 }
             }
             
             if (!bRcvOK) {
             	logger.debug("[iMAPSvrProc().run()] iMAP message is unacceptable!! :\n\r" + strRcvMSG);
             	connectedClientSocket.close();
                 return;
             }
             
				strRcvMSG = strRcvMSG.substring(strRcvMSG.indexOf("<"));
				DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
				DocumentBuilder builder = factory.newDocumentBuilder();
				InputStream istream = new ByteArrayInputStream(strRcvMSG.getBytes("UTF-8"));
				doc = builder.parse(istream);			
				
			    // xpath 생성
		        XPath xpath = XPathFactory.newInstance().newXPath();

		        // id 가 c2 인 Node의 val attribute 값 가져오기
		        Node service = (Node)xpath.evaluate("//imap/service", doc, XPathConstants.NODE);
		        
		        String requestType = service.getAttributes().getNamedItem("type").getTextContent();
		        
//		        // id 가 c3 인 Node 의 value 값 가져오기
//		        logger.debug(xpath.evaluate("//imap/service/model_id", doc, XPathConstants.STRING));
//		        // 값3 출력
		        
		        
		        //logger.debug("~~~~~~~~~~~~~~~request type : " + requestType);
		        String retXML="";
		        if (requestType.equalsIgnoreCase("notice")) {
		        	String requestCmd = service.getAttributes().getNamedItem("name").getTextContent();
		        	if( requestCmd.equalsIgnoreCase("msg_device_event"))
					{
						
					}
		        	else 
		        	{
		        		logger.debug("~~~~~~~~~~~~~~~requestCmd : " + requestCmd);
		        	}
					connectedClientSocket.close();
		        }
		        else if (requestType.equalsIgnoreCase("request")) {
		        	logger.debug(strRcvMSG);

		        	String requestCmd = service.getAttributes().getNamedItem("name").getTextContent();
		        	if( requestCmd.equalsIgnoreCase("get_dust_info"))
					{
		        		retXML = ProcdustInfo(doc, DEF.data.getVersion(), DEF.data.getPeriod().toLowerCase(), DEF.data.getKhaiGrade(), DEF.data.getPm10Grade1h(), DEF.data.getPm25Grade1h(), DEF.data.getDustValue() , requestCmd );
					}
		        	
					if (retXML != null)
					{	
						logger.debug(retXML);
						DataOutputStream outstream = new DataOutputStream(connectedClientSocket.getOutputStream());					
						byte[] outBF = retXML.getBytes("euc-kr");
						outstream.write(outBF);
						outstream.flush();
						
						try { Thread.sleep(3000);}catch (Exception e){logger.error("message : " + e); };
						connectedClientSocket.close();
					}	
					
		        }

			}
			catch(Exception e)
			{
				try {connectedClientSocket.close();}catch (Exception E){logger.error("message : " + E);} 
				logger.error("message : " + e);
			}			
	 }
	 
	 public void ProcMsgDeviceStatusPeriodEvent(Document doc , String cmd )
	 {
    	 // 유플러스는 주기보고가 없다.
    	 return;
	 }
	 
	 @Bean
	 public RestTemplate restTemplate() {
	   RestTemplate restTemplate = new RestTemplate();
	   for(HttpMessageConverter<?> messageConverter : restTemplate.getMessageConverters()) {
	     if(messageConverter instanceof AllEncompassingFormHttpMessageConverter) {
	       ((AllEncompassingFormHttpMessageConverter) messageConverter).setCharset(Charset.forName("UTF-8"));
	       ((AllEncompassingFormHttpMessageConverter) messageConverter).setMultipartCharset(Charset.forName("UTF-8"));
	     }
	   }
	   return restTemplate;
	 }
	 
	 public String ProcdustInfo( Document doc , String version , String period, String khaiGrade, String pm10Grade1h, String pm25Grade1h, String dustValue,  String cmd )
	 {
	        String retXML = "";
	        try
	        {
	        	Date now = new Date();
				String ServerTime = new SimpleDateFormat("yyyy:MM:dd-HH:mm:ss" ).format(now);
				
	            retXML= XMLHeader + "   <service type = \"reply\" name= \"" + cmd + "\" result = \"ok\">\r\n"; 
	            retXML += "   <cur_time>" + ServerTime + "</cur_time>\r\n";
	            retXML += "   <version>" + version + "</version>\r\n";
	            retXML += "   <period>" + period + "</period>\r\n";
	            retXML += "   <dust_info>";
	            retXML += "   	<khaiGrade>" + khaiGrade + "</khaiGrade>";
	            retXML += "   	<pm10Grade1h>" + pm10Grade1h + "</pm10Grade1h>";
	            retXML += "   	<pm25Grade1h>" + pm25Grade1h + "</pm25Grade1h>";
	            retXML += "   	<dustValue>" + dustValue + "</dustValue>";
	            retXML += "   </dust_info>"; 		
	            retXML += "   </service>\r\n</imap>";
	            return retXML;
	        }
	        catch(Exception e)
	        {
	        	logger.error("message : " + e);
	            retXML= XMLHeader + "   <service type = \"reply\" name= \"" + cmd + "\" result = \"fail\">\r\n";        
	            retXML += "   </service>\r\n</imap>";
	            return retXML;
	        }
	 }

}
